# homer_gui


## Known Issues / Todo's 

GUI stürzt ab, wenn die Karte in der rviz-Config aktiviert wird. In rviz selbst funktioniert das Anzeigen der Karte.

## Introduction 


### MapTab


![MapTab](images/maptab.png)

Das MapTab ist die zentrale Anzeige und Steuerung des Mappings und der Navigation. Auf der linken Hälfte des Tabs werden alle aktivierten Kartenebenen angezeigt sowie die Roboterpose und eventuelle Points of Interest (POI). Unter der Karte kann durch eine Checkbox ein Gitter aktiviert werden, um Entfernungen besser abschätzen zu können.
Um die Roboterposition zu verändern, muss STRG gedrückt gehalten und gleichzeitig auf die gewünschte Position in der Karte geklickt werden. Die Orientierung des Roboters wird durch STRG-Rechtsklick verändert. Dabei darf kein POI ausgewählt sein.

Die rechte Hälfte des Tabs besteht aus zwei Untertabs: Dem "POIs"-Tab und dem "Map Layers"-Tab. Im Screenshot sind einige Funktionen durch Nummern markiert und nachfolgend erklärt.

POIs werden durch einen einfachen Linksklick in der Karte an der entsprechenden Stelle erstellt. Danach muss auf der rechten Hälfte unter *1* der Name und optional Anmerkungen zu diesem POI ausgefüllt werden. Danach muss das Erstellen durch *Apply* abgeschlossen werden.
Bereits erstellte POIs können in der Karte per Drag-and-Drop verschoben werden. Außerdem kann durch Anklicken in der Karte oder in der Liste in *2* der Name geändert werden.
Wenn ein POI ausgewählt ist, kann seine Orientierung (blauer Pfeil) durch STRG-Rechtsklick geändert werden.

Im Bereich *3* kann das Mapping ein- oder ausgestellt werden, sowie die SLAM- und Masking-Map gespeichert und geladen werden. Außerdem können alle Kartenebenen zurückgesetzt werden.

Im Untertab *Map Layers* kann eine Kartenebene modifiziert sowie einzelne Ebenen deaktiviert werden. Wird eine Checkbox vor einer Ebene deaktiviert, wird auch die zugehörige Ebene deaktiviert und somit nicht mehr angezeigt.
Um eine Ebene zu modifizieren muss sie vorher ausgewählt sein, indem auf den Namen der Ebene geklickt wird (im Screenshot die Masking Map). Anschließend muss in der Karte per Shift-Linksklick ein Polygon zur Auswahl erstellt werden. Die Ecken dieses Polygons können nun per Drag-and-Drop verschoben werden.
Zum Schluss muss im Bereich *6* die Art der Modifizierung ausgewählt und anschließend mit *apply* bestätigt werden.
Mögliche Modifizierungsarten sind "block", mit dem die Belegtheitswahrscheinlichkeit der Zellen im Polygon auf 100% gesetzt wird, mit "obstacle" auf 99% und mit "free" auf 0%.

## Topics 

#### Publisher 
* `robot_face/text_out`
* `/map_manager/modify_map`
* `/or/learn_commands`
* `/or/learn_commands`
* `/or/commands`
* `/map_manager/add_POI`
* `/homer_mapping/userdef_pose`
* `/map_manager/modify_POI`
* `/map_manager/delete_POI`
* `/map_manager/save_map`
* `/map_manager/load_map`
* `/homer_mapping/do_mapping`
* `/map_manager/reset_maps`
* `/map_manager/toggle_map_visibility`
* `/homer_navigation/start_navigation`
* `/homer_navigation/stop_navigation`
* `chatter`
* `/userdef_pose`
* `/add_POI`
* `/modify_POI`
* `/delete_POI`
* `/start_game`
* `/robot_face/text_out`
* `/robot_platform/MoveRobot`
* `/robot_platform/TurnRobot`
* `/robot_platform/StopRobot`
* `/object_detection/detect_objects`
* `/gripping/grip_object`
* `/katana_arm_planner/move_to_point`
* `/r22_RosKatanaModule/unblock_motors`
* `/katana_arm_planner/safe_position`
* `/katana_arm_planner/transport_position`
* `/start_game`
* `/detect_doors`
* `/robot_face/text_out`
* `/robot_face/user_input`
* `speech_rec/UserInputM`
* `/ptu/set_pan_tilt`
* `/gripping/release_object`
* `/gripping/reset`
* `/katana_arm_planner/release`
* `/katana_arm_planner/grip`
* `/homer_navigation/target_reached`
* `/katana_arm_planner/arm_move_finished`
* `/object_detection/detect_planes`
* `/katana_arm_planner/rotate_gripper`
* `/robot_face/text_out`
* `/face_detection/detect_faces`
* `/final_2014/open_oven`
* `/handle_detection/detect_handle_control`
* `/door_detection/detect_door_control`


#### Subscriber
* `/camera/rgb/image_color`
* `/camera/rgb/image_color`
* `/or/obj_learn_primary`
* `/scan`
* `/camera/rgb/image_color`
* `/any_image_src/sensor_msgs/Image`
* `/pose`
* `/map`
* `/map_manager/poi_list`
* `/homer_navigation/path`
* `/following_node/path`
* `/detect_doors`
* `/emergency_button_pressed`
* `/or/obj_learn_primary`
* `/or/obj_learn_primary`
* `/or/obj_learn_primary`
* `/or/learning_status`
* `or/obj_names`



## Launch Files
